<template>
  <div>
    <v-progress-linear
      v-if="isLoading"
      indeterminate
      :active="isLoading"
      color="error" :background-color="$store.state.secondaryColor"
    />
    <div v-if="isLoading && isGenerating" class="generating-wrapper">
      <v-progress-circular
        :size="140"
        :width="7"
        color="#607d8b"
        indeterminate
      />
      <span class="generating-text">
        {{ $t('piece-loader.generating') }}
      </span>
      <span class="generating-subtitle">
        {{ $t('piece-loader.generating-subtitle') }}
      </span>
    </div>
  </div>
</template>

<script lang="ts">
import type { Piece } from '@/data';
import type { Client } from '@/client';
import { ClientStatus } from '@/client';

import {
  showLogin,
  warnPieceOther,
  warnPieceServer,
  warnPieceUnauth,
} from '@/components/dialogs';
import type { PropType } from 'vue';
import { defineComponent } from 'vue';

export default defineComponent({
  props: {
    piecePath: {
      required: true,
      type: String,
    },
    client: {
      required: true,
      type: Object as PropType<Client>,
    },
    piece: {
      default: null,
      type: Object as PropType<Piece | null>,
    },
    appName: {
      default: null,
      type: String,
    },
  },
  data() {
    return {
      isLoading: false,
      isGenerating: false,
    };
  },
  computed: {
    pieceSync: {
      get(): Piece | null {
        return this.piece;
      },
      set(value: Piece | null) {
        this.$emit('update:piece', value);
      },
    },
  },
  mounted() {
    this.loadPiece();
  },
  methods: {
    emitUpdatePiece(piece: Piece) {
      this.$emit('update:piece', piece);
    },
    async loadPiece() {
      this.isLoading = true;
      const piece = await this.tryLoadPiece();
      this.isLoading = false;
      this.pieceSync = piece;
      if (piece) this.emitUpdatePiece(piece);
    },
    async generateNeumaPiece() {
      this.isGenerating = true;
      await this.client.post(`${process.env.VUE_APP_CORPUS_URL}addNewPiece?neuma_id=${this.$route.query.neuma_id}`, {}, { timeout: 600 * 1000 });
      this.isGenerating = true;
      await this.client.loadCorpus(true);
      return (await this.client.loadPiece(this.piecePath, true)).data;
    },
    async tryLoadPiece(): Promise<Piece | null> {
      const pieceReq = await this.client.loadPiece(this.piecePath, true);

      // TODO: display err on page
      switch (pieceReq.status) {
        case ClientStatus.Ok: return pieceReq.data;
        case ClientStatus.Unauth: {
          if (this.client.canLogin) {
            if (await showLogin(this.client)) {
              return this.tryLoadPiece();
            }
          }
          await warnPieceUnauth(this.piecePath);
          break;
        }
        case ClientStatus.Missing: {
          if (this.$route.query.neuma_id) {
            return this.generateNeumaPiece();
          }
          let prefix = '';
          if (this.appName) {
            prefix = `/${this.appName}`;
          }
          this.$router.push(`${prefix}/explore/${this.piecePath}`);

          // await warnPieceMissing(this.piecePath);
          break;
        }
        case ClientStatus.NoResponse: await warnPieceServer(); break;
        default: {
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          const error = pieceReq.error as any;
          if (this.$route.query.neuma_id && error.response.statusText === 'NOT_FOUND') {
            return this.generateNeumaPiece();
          }
          await warnPieceOther();
        }
      }
      return null;
    },
  },
});

</script>

<style lang="scss" scoped>
.generating {
  &-wrapper {
    padding-top: 25vh;
    display: flex;
    flex-direction: column;
    height: calc(100vh - 5px);
    width: 100%;
    justify-content: center;
    align-items: center;
  }

  &-text {
    margin-top: 25vh;
    font-weight: bold;
    font-size: 28px;
  }

  &-subtitle {
    font-size: 14px;
  }

  &-subtitle, &-text {
    color: #607d8b;
  }
}
</style>
